﻿using System;
using System.Collections;
using HeuristicLab.Persistence.Core;
using HeuristicLab.Persistence.Interfaces;
using System.Collections.Generic;

namespace HeuristicLab.Persistence.Default.Decomposers {
  
  public class TypeDecomposer : IDecomposer {    
    public bool CanDecompose(Type type) {
      return type == typeof (Type) ||
             type.FullName == "System.RuntimeType";
    }

    public IEnumerable<Tag> DeCompose(object obj) {
      Type t = (Type) obj;
      yield return new Tag("AssemblyQualifiedName", t.AssemblyQualifiedName);
    }

    public object CreateInstance(Type type) {
      return null;
    }

    public object Populate(object instance, IEnumerable<Tag> objects, Type type) {
      foreach ( var typeName in objects ) {
        return Type.GetType((string)typeName.Value);
      }
      return null;
    }
  }
}
